commit 711a7387e0200c5dda3f9d0a744dae18afb80351
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Tue Dec 23 13:07:35 2025 +0000

    Keep handle open for module dir

diff --git a/src/src/drtables.c b/src/src/drtables.c
index 29ae84bd6..ec9ca3c67 100644
--- a/src/src/drtables.c
+++ b/src/src/drtables.c
@@ -221,7 +221,7 @@ DIR * dd;
 const pcre2_code * regex_islookupmod = regex_must_compile(
   US"^([a-z0-9]+)_lookup\\." DYNLIB_FN_EXT "$", MCS_NOFLAGS, TRUE);
 
-if (!(dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
+if (!(dd = open_module_dir()))
   g = string_cat(g, US"FAIL exim_opendir");
 else
   {
@@ -247,7 +247,6 @@ else
       dlclose(dl);
       }
     }
-  closedir(dd);
   }
 #endif	/*!LOOKUP_MODULE_DIR*/
 return g;
@@ -448,7 +447,7 @@ DEBUG(D_lookup) debug_printf_indent("Total %d built-in lookups\n", lookup_list_c
 
 
 #ifdef LOOKUP_MODULE_DIR
-if (!(dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
+if (!(dd = open_module_dir()))
   {
   EARLY_DEBUG(D_lookup, "Couldn't open %s: not loading lookup modules\n", LOOKUP_MODULE_DIR);
   log_write(0, LOG_MAIN|LOG_PANIC,
@@ -476,7 +475,6 @@ else
 	log_write(0, LOG_MAIN|LOG_PANIC, "%s", errstr);
 	}
       }
-  closedir(dd);
   }
 
 EARLY_DEBUG(D_lookup, "Loaded %d dynamic lookup modules\n", countmodules);
@@ -589,12 +587,11 @@ const pcre2_code * regex_ismodule = regex_must_compile(
     DYNLIB_FN_EXT "$",
   MCS_NOFLAGS, TRUE);
 
-if ((dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
+if ((dd = open_module_dir()))
   {
   for (struct dirent * ent; ent = readdir(dd); )
     if (regex_match_and_setup(regex_ismodule, US ent->d_name, 0, 0))
       list = string_append_listele(list, ' ', expand_nstring[1]);
-  closedir(dd);
 
   if (list)
     fprintf(stream, "Installed modules: %s\n", string_from_gstring(list));
diff --git a/src/src/functions.h b/src/src/functions.h
index fe9d718ea..b2c2626ab 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -1327,7 +1327,7 @@ if (f.running_in_test_harness && f.testsuite_delays) millisleep(millisec);
 /* Taint-checked file opens. Return values/errno per open(2). */
 
 static inline int
-exim_open2(const char *pathname, int flags)
+exim_open2(const char * pathname, int flags)
 {
 if (!is_tainted(pathname)) return open(pathname, flags);
 log_write(0, LOG_MAIN|LOG_PANIC, "Tainted filename '%s'", pathname);
@@ -1344,7 +1344,7 @@ return -1;
 }
 #ifdef EXIM_HAVE_OPENAT
 static inline int
-exim_openat(int dirfd, const char *pathname, int flags)
+exim_openat(int dirfd, const char * pathname, int flags)
 {
 if (!is_tainted(pathname)) return openat(dirfd, pathname, flags);
 log_write(0, LOG_MAIN|LOG_PANIC, "Tainted filename '%s'", pathname);
@@ -1362,7 +1362,7 @@ return -1;
 #endif
 
 static inline FILE *
-exim_fopen(const char *pathname, const char *mode)
+exim_fopen(const char * pathname, const char * mode)
 {
 if (!is_tainted(pathname)) return fopen(pathname, mode);
 log_write(0, LOG_MAIN|LOG_PANIC, "Tainted filename '%s'", pathname);
@@ -1379,6 +1379,18 @@ errno = EACCES;
 return NULL;
 }
 
+#ifdef LOOKUP_MODULE_DIR
+static inline DIR *
+open_module_dir(void)
+{
+if (module_dir)
+  rewinddir(module_dir);
+else
+  module_dir = exim_opendir(CUS LOOKUP_MODULE_DIR);
+return module_dir;
+}
+#endif
+
 /******************************************************************************/
 # if !defined(COMPILE_UTILITY)
 
diff --git a/src/src/globals.c b/src/src/globals.c
index d04feb24f..e5de80ea4 100644
--- a/src/src/globals.c
+++ b/src/src/globals.c
@@ -1101,6 +1101,9 @@ int     mime_is_coverletter    = 0;
 int     mime_is_rfc822         = 0;
 int     mime_part_count        = -1;
 #endif
+#ifdef LOOKUP_MODULE_DIR
+DIR *	module_dir	       = NULL;
+#endif
 
 uid_t  *never_users            = NULL;
 uschar *notifier_socket        = US"$spool_directory/" NOTIFIER_SOCKET_NAME ;
diff --git a/src/src/globals.h b/src/src/globals.h
index 52c46f169..313062890 100644
--- a/src/src/globals.h
+++ b/src/src/globals.h
@@ -769,6 +769,9 @@ extern int     mime_is_coverletter;
 extern int     mime_is_rfc822;
 extern int     mime_part_count;
 #endif
+#ifdef LOOKUP_MODULE_DIR
+extern DIR *   module_dir;
+#endif
 
 extern BOOL    mua_wrapper;            /* TRUE when Exim is wrapping an MUA */
 
diff --git a/src/src/readconf.c b/src/src/readconf.c
index 7840fd0ac..417a786e3 100644
--- a/src/src/readconf.c
+++ b/src/src/readconf.c
@@ -3819,7 +3819,7 @@ for (di = *info_anchor; di; di = di->next)
 #ifdef LOOKUP_MODULE_DIR
 /* Potentially a loadable module. Look for a file with the right name. */
 
-if (!(dd = exim_opendir(CUS LOOKUP_MODULE_DIR)))
+if (!(dd = open_module_dir()))
   log_write(0, LOG_MAIN|LOG_PANIC,
 	  "Couldn't open %s: not loading driver modules\n", LOOKUP_MODULE_DIR);
 else
@@ -3828,7 +3828,7 @@ else
 				  d->driver_name, class);
   const char * errormsg;
 
-  DEBUG(D_any) debug_printf("Loading %s %s driver from %s\n",
+  DEBUG(D_any) debug_printf("Loading %q %s driver from %s\n",
 			    d->driver_name, class, LOOKUP_MODULE_DIR);
 
   for(struct dirent * ent; ent = readdir(dd); ) if (Ustrcmp(ent->d_name, fname) == 0)
@@ -3866,7 +3866,6 @@ else
 	store_pool = old_pool;
 	DEBUG(D_any)
 	  debug_printf("Loaded module %q (%s)\n", d->driver_name, class);
-	closedir(dd);
 	goto found;
 	}
 
@@ -3876,7 +3875,6 @@ else
     dlclose(dl);
     break;
     }
-  closedir(dd);
   }
 #endif	/* LOOKUP_MODULE_DIR */
 

